CON

'' Primative web server example for wifi/serial module By Jeff Ledger
'' Recommend to set AT+TCPTO=10 (or lower) to make the server close the socket connection in reasonable time.

   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000

   video     = 16                      ' Video output

   serXmit   = 12                      ' Serial Transmit
   serRecv   = 13                      ' Serial Receive
   baud      = 57600                   ' Baud Rate

VAR

 byte  filename[51]
 byte  pagecounter
 
OBJ

  text   : "VGA_1024"                     ' VGA Terminal Driver
  ser    : "Extended_FDSerial"
  
PUB start | i, a, b, TimeCnt

  text.start(video)                             ' Start terminal screen
  ser.start(serRecv,serXmit,0,baud)             ' Control link via prop-plug
  ser.SetDelimiter(" ")
  titlescreen
  terminal

PUB terminal | record,remote,headercheck

  headercheck:=0    '' Examines header one time to search for filename
  pagecounter:=0
  
  repeat

      remote := ser.rxcheck

      if remote == 47 and headercheck == 0 '' Look for the first / indicating the requested file.
         text.cls
         ser.Rxstr(@filename)
         text.str(string("Requested page: "))
         text.str(@filename)
         text.out(13)
         text.str(string("Hit counter: "))
         text.dec(pagecounter)
         text.out(13)
         text.out(13)
         text.str(string("GET /"))
         text.str(@filename)
         text.str(string(" "))
         headercheck:=1
         
      if remote == 13 and record == 10 ''Watch for the end of the http request header
         headercheck:=0
         
         
         displaypage  '' Display requested page after header is finsihed being received.
             
      if remote > 11
          text.out(remote)

      record:=remote ''record last byte

PUB displaypage  | errorpage,hitcounter

      errorpage := 1 ''Pessimistically assume the page won't be found and prepare to display 404 error page.
      
      
      if strcomp(string("index.html"),@filename) or filename[0]==0

            pagecounter++  
            ser.str(@HTMLHead)

            repeat 500 ''Buy some time to allow the browser to catch up. Weak, but works.
              ser.str(string(" ",13,10)) 

            '' Content of the webpage.  Each line must end with carriage return and linefeed.
            
            ser.str(string("<html>",13,10))
            ser.str(string("<title>Propeller Serial/Wifi Webserver</title>",13,10))
            ser.str(string("<body>",13,10))
            ser.str(string("<h1>Page served from the Propeller!</h1>",13,10))
            ser.str(string("<BR><BR>Page hitcounter since reload: ",13,10))
            ser.dec(pagecounter)
            ser.str(string("<BR><BR>",13,10))
            ser.str(string("</body>",13,10))
            ser.str(string("</html>",13,10))
            errorpage:=0

      if strcomp(string("favicon.ico"),@filename)  '' Do something cool with this later
            errorpage:=0

      
      if errorpage == 1
            ser.str(@E404Head)
            repeat 500  ''Buy some time to allow the browser to catch up. Weak, but works. 
               ser.str(string(" ",13,10))

            ser.str(string("<html><head>",13,10))
            ser.str(string("<title>404 Not Found</title>",13,10))
            ser.str(string("</head><body>",13,10))
            ser.str(string("<h1>Not Found</h1>",13,10))
            ser.str(string("<p>The requested URL /",13,10))
            ser.str(@filename)
            ser.str(string(" was not found on this server.</p>",13,10))
            ser.str(string("<p>Additionally, a 404 Not Found error was encountered while trying to use an ErrorDocument to handle this request.</p>",13,10))
            ser.str(string("<hr>",13,10))
            ser.str(string("<address>Propeller Serial/Wifi Webserver</address>",13,10))
            ser.str(string("</body></html>",13,10))
            

            
      bytefill(@filename, 0, 50)  '' clear the filename after the page is transmitted  
      

            
PUB titlescreen

  text.cls
  text.str(string(13,"Primitive Webserver by: Jeff Ledger",13))
  text.str(string("Waiting for a request: "))
  text.dec(baud)
  text.str(string(",N,8,1",13))

DAT

HTMLHead byte "HTTP/1.1 200 OK",10,13,"Connection: close",10,13,"Content-Type: text/html",10,13,10,13,0

E404Head byte "HTTP/1.1 404 Not Found",10,13,"Content-Type: text/html",10,13,10,13,0
 